package com.laihua.projecthelper.stringxml

import com.laihua.projecthelper.implement.belongModule
import org.jdom2.input.SAXBuilder
import java.io.File

/**
 * Author: pengjunjing
 * Date: 2022/3/11
 * Description:string的xml文件解析类
 */
class StringXmlParse {

    companion object {

        const val resourcesStringDef = "resources"

    }

    /**
     * 将字符串文件解析成对象
     */
    fun parseToObj(stringXmlFile: File): StringXmlResCode {
        val document = SAXBuilder().build(stringXmlFile)
        val rootElement = document.rootElement
        val belongModule = stringXmlFile.belongModule()
        val stringXmlResCode = StringXmlResCode(stringXmlFile, belongModule)
        //读取resources节点下的内容
        if (belongModule != null && resourcesStringDef == rootElement.name) {
            val children = rootElement.children
            for (child in children) {
                if (child.name == "string") {
                    //获取string节点的数据
                    val stringElement =
                        StringElement(stringXmlFile, belongModule, child.attributes[0].value, child.value)
                    stringXmlResCode.stringElementList.add(stringElement)
                }
            }

        }
        return stringXmlResCode
    }

    /**
     * 删除掉一个xml文件字符串内容
     */
    fun deleteStringXmlElement(stringElement: StringElement) {
        val document = SAXBuilder().build(stringElement.file)
        val rootElement = document.rootElement
        rootElement.removeChild(stringElement.attributeName)
        //todo 删除工作
    }

}